<template>
	<view class="search-scenic">
		<view class="search-box">
			<view class="city-box">
		  <image class="icon" src="@/static/blue-position.png" mode=""></image>	
		  <view class="city">
		  	{{city}}
		  </view>
			</view>
		  <input class="search" v-model="query.queryName" focus type="text" placeholder="景点名称" />
		</view>
		
		<zs-list class="list" mt="0" @load="loadMore" :status="status">
			<view class="item" v-for="(item,index) in list" :key="index" @click="goDetail(item)">
				<zs-img :src="item.logoPath" width="200rpx" height="200rpx" radius="full" mode="center"></zs-img>
				<view class="info">
					<view class="title">
						{{item.tripartiteJson.scenicName}}
					</view>
					<view class="address-box">
						<view class="price-box">
							<view class="unit">
								￥
							</view>
							<view class="price">
									{{item.tripartiteJson.ticketList | filterMinPrice}}
							</view>
							<view class="text">
								起
							</view>
						</view>
						<!-- <view class="address">
							重庆
						</view> -->
						<view class="distance">
							{{(item.shopVo.distance/1000).toFixed(2)}} KM
						</view>
					</view>
				</view>
			</view>
			
		</zs-list>
		
	</view>
</template>

<script>
	import {debounce} from '@/utils/tool.js'
	import { search } from '@/api/shop.js';
	export default {
		data() {
			return {
				city: uni.getStorageSync('city'),
				status:'more',
				list:[],
				query:{
					queryName:'',
					menuId: 1,
					range:1000,
					'location.lat':0,
					'location.lon':0,
					pageCurrent:1,
					pageSize:10
				},
			}
		},
		watch: {
			'query.queryName':debounce(function(val) {
				this.query.pageCurrent = 1
				this.list = []
				this.status = 'more'
				if(val){
					this.query.range = 9999
				}else{
					this.query.range = 1000
				}
					this.search()
			})
		},
		filters: {
			filterDistance: function(item) {
				if(!item.glocation) return '-'
				let blocation = item.glocation.split(',')
				let location = JSON.parse(uni.getStorageSync('location'))
				/*参数：两地的经纬度数值*/
				    var radLat1 = location.latitude * Math.PI / 180.0;
				    var radLat2 = blocation[0]* Math.PI / 180.0;
				    var a = radLat1 - radLat2;
				    var b = location.longitude* Math.PI / 180.0 - blocation[1]* Math.PI / 180.0;
				    var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) +
				    Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
				    s = s * 6378137.0;//地球半径 单位米;
				    s = Math.round(s * 10000) / 10000 /1000 //输出为千米
				    s = s.toFixed(0)
				    return s
				
			},
			filterMinPrice(list){
				if(list.length){
					let arr = JSON.parse(JSON.stringify(list))
					arr.sort(function(a,b){ return a.salePrice - b.salePrice})
					return arr[0].salePrice
					console.log(arr);
				}else{
					return 0
				}
			}
		},
		methods: {
			loadMore(){
				this.search()
			},
			// getScenicList(){
			// 	// if(!this.query.key) return
			// 	this.status = 'loading'
			// 	getScenicList(this.query).then(res=>{
			// 		if(res.state == 'Success'){
			// 			this.list = this.list.concat(res.content.data.rows)
			// 			if(this.list.length>= res.content.data.totalCount){
			// 				this.status = 'noMore'
			// 			}else{
			// 				this.status = 'more'
			// 				this.query.page++
			// 			}
			// 		}
			// 	})
			// },
			search() {
				if(this.status == 'noMore' || this.status == 'loading' || !this.query['location.lat']) return
				this.status = 'loading'
				search(this.query).then(res=>{
					if(res.state == 'Success'){
						let data = res.content.records
						data.map((item,index)=>{
							item.tripartiteJson = JSON.parse(item.tripartiteJson)
						})
						this.list = this.list.concat(data)
						console.log('加载数据',this.status,this.list,this.query.pageCurrent);
						if(this.query.pageCurrent >= res.content.pages){
							this.status = 'noMore'
						}else{
							this.status = 'more'
							this.query.pageCurrent++
						}
					}
				})
			},
			goDetail(item){
				uni.navigateTo({
					url:`/scenic/detail?id=${item.tripartiteJson.scenicId}&epId=${item.shopVo.shopId}`
				})
			}
		},
		onLoad() {
			uni.setNavigationBarTitle({
				title: uni.getStorageSync('city')
			});
			uni.getLocation({
					type: 'gcj02',
					success: (res) => {
						// 解析地址
						this.query['location.lat'] = res.latitude
						this.query['location.lon'] = res.longitude
						console.log(this);
						// 存储经纬度
						uni.setStorageSync('location',JSON.stringify({latitude:res.latitude,longitude:res.longitude}))
						this.search()
					}
			})
		}
	}
</script>

<style lang="scss" >
.search-scenic{
	min-height: 100vh;
	padding: 112rpx 24rpx 0;
	.search-box{
		position: fixed;
		top: 0;
		left: 0;
		width: 100%;
		height: 72rpx;
		padding: 20rpx 24rpx;
		z-index: 9;
		background: #fff;
		.city-box{
			position: absolute;
			left: 20rpx;
			top: 50%;
			transform: translateY(-50%);
			display: flex;
			align-items: center;
			padding: 0 28rpx;
			border-right: 1rpx solid #F0F0F0;
			.icon{
				width: 30rpx;
				height: 30rpx;
			}
			.city{
				font-weight: 600;
				font-size: 28rpx;
				color: #222222;
				margin-left: 6rpx;
			}
		}
		.search{
			width: 702rpx;
			height: 72rpx;
			border-radius: 40rpx 40rpx 40rpx 40rpx;
			padding-left: 230rpx;
			padding-right: 100rpx;
			box-sizing: border-box;
			background: #F6F6F6;
		}
	}
	.zs-list{
		.item{
			background: #FFFFFF;
			border-radius: 16rpx;
			display: flex;
			padding: 12rpx 0;
			border-bottom: 1rpx solid #F0F0F0;
			.zs-img{
				width: 200rpx;
			}
			.info{
				flex: 1;
				padding: 30rpx 20rpx 20rpx;
				box-sizing: border-box;
				display: flex;
				flex-direction: column;
				justify-content: space-between;
				.title{
					font-weight: 400;
					font-size: 24rpx;
					color: #222222;
					width: 450rpx;
					white-space: nowrap;
					overflow: hidden;
					text-overflow: ellipsis;
				}
				.price-box{
					display: flex;
					align-items: flex-end;
					margin-top: 12rpx;
					.unit{
						font-weight: 600;
						font-size: 20rpx;
						color: $uni-color-primary;
					}
					.price{
						font-weight: 600;
						font-size: 36rpx;
						color: $uni-color-primary;
					}
					.text{
						font-weight: 300;
						font-size: 24rpx;
						color: #AAAAAA;
						margin-left: 6rpx;
					}
				}
				.address-box{
					display: flex;
					align-items: flex-end;
					justify-content: space-between;
					font-weight: 300;
					font-size: 20rpx;
					color: #AAAAAA;
					margin-top: 12rpx;
				}
			}
		}
	}
}
</style>